searchNodes=[{"type":"task","title":"Mix.Tasks.Trans.Gen.TranslateFunction","doc":"Generates a migration to add a database function translate_field that uses the Trans structured translation schema to resolve a translation for a field.","ref":"Mix.Tasks.Trans.Gen.TranslateFunction.html"},{"type":"function","title":"Mix.Tasks.Trans.Gen.TranslateFunction.format_string!/1","doc":"","ref":"Mix.Tasks.Trans.Gen.TranslateFunction.html#format_string!/1"},{"type":"function","title":"Mix.Tasks.Trans.Gen.TranslateFunction.migrations_path/1","doc":"","ref":"Mix.Tasks.Trans.Gen.TranslateFunction.html#migrations_path/1"},{"type":"module","title":"Trans","doc":"Manage translations embedded into structs. Although it can be used with any struct Trans shines when paired with an Ecto.Schema . It allows you to keep the translations into a field of the schema and avoids requiring extra tables for translation storage and complex joins when retrieving translations from the database. Trans is split into two main components: Trans.Translator - provides easy access to struct translations. Trans.QueryBuilder - provides helpers for querying translations using Ecto.Query (requires Ecto.SQL ). When used, Trans accepts the following options: :translates (required) - list of the fields that will be translated. :container (optional) - name of the field that contains the embedded translations. Defaults to :translations . :default_locale (optional) - declares the locale of the base untranslated column. Storing translations To store translations in a schema you must use the translations macro: defmodule MyApp.Article do use Ecto.Schema use Trans , translates : [ :title , :body ] , default_locale : :en schema &quot;articles&quot; do field :title , :string field :body , :string translations [ :es , :fr ] end end This is equivalent to: defmodule MyApp.Article do use Ecto.Schema use Trans , translates : [ :title , :body ] , default_locale : :en schema &quot;articles&quot; do field :title , :string field :body , :string embeds_many :translations , Translations , primary_key : :false do embeds_one :es , Fields embeds_one :fr , Fields end end end defmodule MyApp.Article.Translations.Fields do use Ecto.Schema embedded_schema do field :title , :string field :body , :string end end If you want to customize the translation fields (for example how they are casted) you may define them yourself manually. In such cases you may tell Trans not to generate the fields automatically for you: defmodule MyApp.Article do use Ecto.Schema use Trans , translates : [ :title , :body ] , default_locale : :en schema &quot;articles&quot; do field :title , :string field :body , :string # Define MyApp.Article.Translations.Fields yourself translations [ :es , :fr ] , build_field_schema : false end end The translation container As we have seen in the previous examples, Trans automatically stores and looks for translations in a field called :translations . This is known as the translations container. In certain cases you may want to use a different field for storing the translations, this can be specified when using Trans in your module. # Use the field `:locales` as translation container instead of the default `:translations` use Trans , translates : [ ... ] , container : :locales Reflection Any module that uses Trans will have an autogenerated __trans__ function that can be used for runtime introspection of the translation metadata. __trans__(:fields) - Returns the list of translatable fields. __trans__(:container) - Returns the name of the translation container. __trans__(:default_locale) - Returns the name of default locale.","ref":"Trans.html"},{"type":"function","title":"Trans.translatable?/2","doc":"Checks whether the given field is translatable or not. Returns true if the given field is translatable. Raises if the given module or struct does not use Trans . Examples Assuming the Article schema defined before. If we want to know whether a certain field is translatable or not we can use this function as follows: iex&gt; Trans . translatable? ( Article , :title ) true iex&gt; Trans . translatable? ( % Article { } , :not_existing ) false Raises if the given module or struct does not use Trans : iex&gt; Trans . translatable? ( Date , :day ) ** (RuntimeError) Elixir.Date must use `Trans` in order to be translated","ref":"Trans.html#translatable?/2"},{"type":"macro","title":"Trans.translations/2","doc":"Create the translation container and fields. This macro creates a field named like the module's translation container to store the translations. By default YourModule.Translations and YourModule.Translations.Fields schemas will be created. This macro creates an embedded field named after your &quot;translation container&quot; of type YourModule.Translations . This field in turn has an embedded field for each locale of type YourModule.Translations.Fields . Calling: translations [ :en , :es ] Is equivalent to: embeds_one :translations , Translations do embeds_one :en , Fields embeds_one :es , Fields end Options build_field_schema (boolean / default: false) wether to automatically generate the module for locales or not. Set this to false if you want to customize how the field translations are stored and keep in mind that you must create a YourModule.Translations.Fields schema.","ref":"Trans.html#translations/2"},{"type":"type","title":"Trans.locale/0","doc":"A locale that may be a string or an atom","ref":"Trans.html#t:locale/0"},{"type":"type","title":"Trans.locale_list/0","doc":"When translating or querying either a single locale or a list of locales can be provided","ref":"Trans.html#t:locale_list/0"},{"type":"type","title":"Trans.translatable/0","doc":"A translatable struct that uses Trans","ref":"Trans.html#t:translatable/0"},{"type":"module","title":"Trans.QueryBuilder","doc":"Provides helpers for filtering translations in Ecto.Queries . This module requires Ecto.SQL to be available during the compilation.","ref":"Trans.QueryBuilder.html"},{"type":"macro","title":"Trans.QueryBuilder.translated/3","doc":"Generates a SQL fragment for accessing a translated field in an Ecto.Query . The generated SQL fragment can be coupled with the rest of the functions and operators provided by Ecto.Query and Ecto.Query.API . Safety This macro will emit errors when used with untranslatable schema modules or fields. Errors are emitted during the compilation phase thus avoiding runtime errors after the queries are built. Examples Assuming the Article schema defined in Trans : # Return all articles that have a Spanish translation from a in Article , where : translated ( Article , a , :es ) != &quot;null&quot; #=&gt; SELECT a0.&quot;id&quot;, a0.&quot;title&quot;, a0.&quot;body&quot;, a0.&quot;translations&quot; #=&gt; FROM &quot;articles&quot; AS a0 #=&gt; WHERE a0.&quot;translations&quot;-&gt;&quot;es&quot; != &#39;null&#39; # Query items with a certain translated value from a in Article , where : translated ( Article , a . title , :fr ) == &quot;Elixir&quot; #=&gt; SELECT a0.&quot;id&quot;, a0.&quot;title&quot;, a0.&quot;body&quot;, a0.&quot;translations&quot; #=&gt; FROM &quot;articles&quot; AS a0 #=&gt; WHERE ((a0.&quot;translations&quot;-&gt;&quot;fr&quot;-&gt;&gt;&quot;title&quot;) = &quot;Elixir&quot;) # Query items using a case insensitive comparison from a in Article , where : ilike ( translated ( Article , a . body , :es ) , &quot;%elixir%&quot; ) #=&gt; SELECT a0.&quot;id&quot;, a0.&quot;title&quot;, a0.&quot;body&quot;, a0.&quot;translations&quot; #=&gt; FROM &quot;articles&quot; AS a0 #=&gt; WHERE ((a0.&quot;translations&quot;-&gt;&quot;es&quot;-&gt;&gt;&quot;body&quot;) ILIKE &quot;%elixir%&quot;) Fallback chains Just like when using Trans.Translator.translate/2 you may also pass a list of locales. In that case the query will automatically fall back through the list of provided locales until it finds an existing translation. # Query items translated into FR or ES (if FR translation does not exist) from a in Article , where : not is_nil ( translated ( Article , a . body , [ :fr , :es ] ) ) If you plan to use fallback chains in the database you will need to set up the Trans DB translation functions. mix do trans . gen . translate_function , ecto . migrate More complex queries The translated/3 macro can also be used with relations and joined schemas. For more complex examples take a look at the QueryBuilder tests (the file is located in test/trans/query_builder_test.ex ).","ref":"Trans.QueryBuilder.html#translated/3"},{"type":"macro","title":"Trans.QueryBuilder.translated_as/3","doc":"Generates a SQL fragment for accessing a translated field in an Ecto.Query select clause and returning it aliased to the original field name. Therefore, this macro returned a translated field with the name of the table's base column name which means Ecto can load it into a struct without further processing or conversion. In practise it call the macro translated/3 and wraps the result in a fragment with the column alias.","ref":"Trans.QueryBuilder.html#translated_as/3"},{"type":"module","title":"Trans.Translator","doc":"Provides easy access to struct translations. Although translations are stored in regular fields of an struct and can be accessed directly, it is recommended to access translations using the functions provided by this module instead. This functions present additional behaviours such as: Checking that the given struct uses Trans Automatically inferring the translation container when needed. Falling back along a locale fallback chain (list of locales in which to look for a translation). If not found, then return the default value or raise and exception if a translation does not exist. Translating entire structs. All examples in this module assume the following article, based on the schema defined in Structured translations article = % MyApp.Article { title : &quot;How to Write a Spelling Corrector&quot; , body : &quot;A wonderful article by Peter Norvig&quot; , translations : % MyApp.Article.Translations { es : % MyApp.Article.Translations.Fields { title : &quot;Cómo escribir un corrector ortográfico&quot; , body : &quot;Un artículo maravilloso de Peter Norvig&quot; } , fr : % MyApp.Article.Translations.Fields { title : &quot;Comment écrire un correcteur orthographique&quot; , body : &quot;Un merveilleux article de Peter Norvig&quot; } } }","ref":"Trans.Translator.html"},{"type":"function","title":"Trans.Translator.translate/2","doc":"Translate a whole struct into the given locale. Translates the whole struct with all translatable values and translatable associations into the given locale. Similar to translate/3 but returns the whole struct. Examples Assuming the example article in this module, we can translate the entire struct into Spanish: # Translate the entire article into Spanish article_es = Trans.Translator . translate ( article , :es ) article_es . title #=&gt; &quot;Cómo escribir un corrector ortográfico&quot; article_es . body #=&gt; &quot;Un artículo maravilloso de Peter Norvig&quot; Just like translate/3 , falls back to the default locale if the translation does not exist: # The Deutsch translation does not exist so the default values are returned article_de = Trans.Translator . translate ( article , :de ) article_de . title #=&gt; &quot;How to Write a Spelling Corrector&quot; article_de . body #=&gt; &quot;A wonderful article by Peter Norvig&quot; Rather than just one locale, a list of locales (a locale fallback chain) can also be used. In this case, translation tries each locale in the fallback chain in sequence until a translation is found. If none is found, the default value is returned. # The Deutsch translation does not exist but the Spanish one does article_de = Trans.Translator . translate ( article , [ :de , :es ] ) article_de . title #=&gt; &quot;Cómo escribir un corrector ortográfico&quot; article_de . body #=&gt; &quot;Un artículo maravilloso de Peter Norvig&quot;","ref":"Trans.Translator.html#translate/2"},{"type":"function","title":"Trans.Translator.translate/3","doc":"Translate a single field into the given locale. Translates the field into the given locale or falls back to the default value if there is no translation available. Examples Assuming the example article in this module: # We can get the Spanish title: Trans.Translator . translate ( article , :title , :es ) &quot;Cómo escribir un corrector ortográfico&quot; # If the requested locale is not available, the default value will be returned: Trans.Translator . translate ( article , :title , :de ) &quot;How to Write a Spelling Corrector&quot; # A fallback chain can also be used: Trans.Translator . translate ( article , :title , [ :de , :es ] ) &quot;Cómo escribir un corrector ortográfico&quot; # If we request a translation for an invalid field, we will receive an error: Trans.Translator . translate ( article , :fake_attr , :es ) ** (RuntimeError) &#39;Article&#39; module must declare &#39;fake_attr&#39; as translatable","ref":"Trans.Translator.html#translate/3"},{"type":"function","title":"Trans.Translator.translate!/3","doc":"Translate a single field into the given locale or raise if there is no translation. Just like translate/3 gets a translated field into the given locale. Raises if there is no translation available. Examples Assuming the example article in this module: Trans.Translator . translate! ( article , :title , :de ) ** (RuntimeError) translation doesn&#39;t exist for field &#39;:title&#39; in locale &#39;de&#39;","ref":"Trans.Translator.html#translate!/3"}]